#include "testlib.h"

using namespace std;

typedef long long int ll;

struct group
{
	string name;
	int MAX_N;
	int MAX_K;
	int MAX_COST;
};

const int CNT_GROUP = 5;

group groups[CNT_GROUP] =
{
	{
		.name = "samples",
		.MAX_N = 20,
		.MAX_K = 20,
		.MAX_COST = 20
	},
	{
		.name = "group1",
		.MAX_N = 20,
		.MAX_K = 20,
		.MAX_COST = 20
	},
	{
		.name = "group2",
		.MAX_N = 100,
		.MAX_K = 100,
		.MAX_COST = 100
	},
	{
		.name = "group3",
		.MAX_N = 1000 * 1000,
		.MAX_K = 1000 * 1000,
		.MAX_COST = 1000 * 1000
	},
	{
		.name = "group4",
		.MAX_N = 2000 * 1000 * 1000,
		.MAX_K = 2000 * 1000 * 1000,
		.MAX_COST = 2000 * 1000 * 1000
	},
};


int main(int argc, char **argv)
{
	registerValidation(argc, argv);
	
	int group_id = -1;

	for (int i = 0; i < CNT_GROUP; ++i)
	{
		if (groups[i].name == validator.group())
		{
			group_id = i;
			break;
		}
	}

	ensuref(group_id != -1, "no group for this test");	
	
	inf.readInt(1, groups[group_id].MAX_N, "n");
	inf.readEoln();
	
	inf.readInt(1, groups[group_id].MAX_K, "k");
	inf.readEoln();
	
	inf.readInt(1, groups[group_id].MAX_COST, "A");
	inf.readEoln();
	
	inf.readInt(1, groups[group_id].MAX_COST, "B");
	inf.readEoln();
	
	inf.readEof();

	return 0;
}

