#include "testlib.h"

using namespace std;

typedef long long int ll;

struct group
{
	string name;
	int MAX_LEN;
};

const int CNT_GROUP = 5;

group groups[CNT_GROUP] =
{
	{
		.name = "samples",
		.MAX_LEN = 3		
	},
	{
		.name = "group1",
		.MAX_LEN = 3
	},
	{
		.name = "group2",
		.MAX_LEN = 10
	},
	{
		.name = "group3",
		.MAX_LEN = 5000	
	},
	{
		.name = "group4",
		.MAX_LEN = 100 * 1000
	},
};

bool solution_exist(string st, int n, int k)
{
	if (k > n) return true;

	set<char> have;
	for (int i = 0; i < n; ++i)
	{
		have.insert(st[i]);
	}

	for (int i = 0; i < k; ++i)
	{
		if (st[i] != *have.rbegin()) return true;
	}

	return false;
}

int main(int argc, char **argv)
{
	registerValidation(argc, argv);
	
	int group_id = -1;

	for (int i = 0; i < CNT_GROUP; ++i)
	{
		if (groups[i].name == validator.group())
		{
			group_id = i;
			break;
		}
	}

	ensuref(group_id != -1, "no group for this test");	
	
	int n = inf.readInt(1, groups[group_id].MAX_LEN, "n");
	inf.readEoln();
	
	string st = inf.readToken("[a-z]{" + vtos(n) + "}");
	inf.readEoln();
	
	int k = inf.readInt(1, groups[group_id].MAX_LEN, "k");
	inf.readEoln();
	
	ensuref(solution_exist(st, n, k), "Solution must exist");

	inf.readEof();

	return 0;
}

