#include <bits/stdc++.h>
#include "testlib.h"
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

const int MAXN = 100 * 1000;
const int MAXA = 1000 * 1000 * 1000;

int t[MAXN + 1], n;
string s;

ll readAns(InStream& in, TResult flag) {
    ll tmin = in.readInt(-MAXA, MAXA);
    ll tmax = in.readInt(-MAXA, MAXA);

    if (tmin > tmax) {
        quitf(flag, "tmin should be less or equal to tmax");
    }


    string res = "0000";
    bool turnedIn = false;
    for (int i = 4; i < n; i++) {
        int mn = MAXA;
        int mx = -MAXA;
        bool allZeroes = true;
        bool allOnes = true;
        for (int j = i - 4; j <= i; j++) {
            mn = min(mn, t[j]);
            mx = max(mx, t[j]);
            
            if (j < i && res[j] == '1') {
                allZeroes = false;
            }
            if (j < i && res[j] == '0') {
                allOnes = false;
            }
        }

        if (mx < tmin && allZeroes) {
            turnedIn = true;
            res += "1";
        } else if (mn > tmax && allOnes) {
            turnedIn = false;
            res += "0";
        } else if (turnedIn) {
            res += "1";
        } else {
            res += "0";
        }
    }
    

    if (res != s) {
        quitf(flag, "the heater's sequence is %s, but %s is found", s.c_str(), res.c_str());
    }
    
    return tmax - tmin;
}

void SkipGroup(InStream& test) {
    static const char rareChar = '%';
    static const std::string randomString = "forever_papich";
    static const std::string groupToken = "GROUP: ";
    static const char terminalToken = '#';

    std::string toParse = randomString + groupToken;

     {
        char c = test.readChar();
        if (c != rareChar) {
            test.unreadChar(c);
            return;
        }
    }
    
    std::string read;
    for (size_t i = 0; i < toParse.size(); i++) {
        if (!test.eof()) {
            read += test.readChar();
        }
    }

    ensuref(!test.eof() && read == toParse, "Bad fake group format");

    std::string group;

    char c = test.readChar();
    while (c != terminalToken) {
        group += c;
        ensuref(!test.eof(), "Bad fake group format");
        c = test.readChar();
    }

    test.readEoln();
}

int main(int argc, char * argv[]) {
    //cin.tie(0), ios::sync_with_stdio(0);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    registerTestlibCmd(argc, argv);

    SkipGroup(inf);
    
    n = inf.readInt();

    for(int i = 0; i < n; i++) {
        t[i] = inf.readInt();
    }

    s = inf.readToken();

    ll j = readAns(ans, _fail);
    ll p = readAns(ouf, _wa);
    
    if (j < p) {
        quitf(_wa, "Jury has the better answer than participant: jans = %lld, pans = %lld\n", j, p);
    } else if (j == p) {
        quitf(_ok, "Jury and participant agree: answer = %lld\n", j);
    } else { // j > p FAIL
        quitf(_fail, "Participant has the better answer than jury: jans = %lld, pans = %lld\n", j, p);
    }

    return 0;
}
