#include "testlib.h"
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

// examples of use
// (s = 0 -> in lexicographical order, otherwise in reversed order)
// (s, n) - n numbers from 1 to 10e9, sorted 
// (s, n, a, b) - n numbers from a to b, sorted
// (s, n, swap) - n numbers from 1 to 10e9, sorted, random SWAP elements swapped
// (s, n, a, b, swap) - n numbers from a to b, sorted, random SWAP elements swapped

int main(int argc, char* argv[])
{
	registerGen(argc, argv, 1);

    int sorted = atoi(argv[1]);
	int n = atoi(argv[2]);
    int lower_bound = 1, upper_bound = 1000000000;
    int swaps = 0;
    if (argc == 4) {
        swaps = atoi(argv[3]);
    } else if (argc == 5) {
        lower_bound = atoi(argv[3]);
        upper_bound = atoi(argv[4]);
    } else if (argc > 5) {
        lower_bound = atoi(argv[3]);
        upper_bound = atoi(argv[4]);
        swaps = atoi(argv[5]);
    }

    vector<int> arr(n);
    for (int i = 0; i < n; i++)
        arr[i] = rnd.next(lower_bound, upper_bound);
    sort(arr.begin(), arr.end());
    if (sorted == 1)
        reverse(arr.begin(), arr.end());

    for (int s = 0; s < swaps; s++) {
        int a = rnd.next(0, n - 1);
        int b = rnd.next(0, n - 1);
        swap(arr[a], arr[b]);
    }

	cout << n << endl;
	for (int i = 0; i < n; i++) {
		cout << arr[i];
		if (i != n - 1)
			cout << " ";
	}
	cout << endl;
}
