#include <iostream>
#include <vector>
#include <algorithm>
#include <climits>
using namespace std;


struct tree {
    int n;
    vector<pair<int64_t, int64_t>> t;

    void init(int n) {
        this->n = n;
        t.resize(4 * n);
    }

    void put(int v, int l, int r, int pos, int value) {
        if (l == r) {
            t[v] = { 1, value };
        } else {
            if (pos <= (l + r) / 2)
                put(v * 2, l, (l + r) / 2, pos, value);
            else
                put(v * 2 + 1, (l + r) / 2 + 1, r, pos, value);
            t[v].first = t[v * 2].first + t[v * 2 + 1].first;
            t[v].second = t[v * 2].second + t[v * 2 + 1].second;
        }
    }

    void put(int pos, int value) {
        put(1, 0, n - 1, pos, value);
    }

    int64_t get(int v, int l, int r, int cnt) {
        if (cnt == 0)
            return 0;
        if (cnt >= t[v * 2].first)
            return t[v * 2].second + get(v * 2 + 1, (l + r) / 2 + 1, r, cnt - t[v * 2].first);
        else
            return get(v * 2, l, (l + r) / 2, cnt);
    }

    int64_t get(int cnt) {
        return t[1].second - get(1, 0, n - 1, cnt);
    }
};

int main() {
    int n;
    cin >> n;

    vector<int> products(n);
    for (int i = 0; i < n; i++)
        cin >> products[i];

    vector<pair<int, int>> sorted(n);
    for (int i = 0; i < n; i++)
        sorted[i] = { products[i], i };
    sort(sorted.begin(), sorted.end());
    vector<int> number(n);
    for (int i = 0; i < n; i++)
        number[sorted[i].second] = i;

    vector<vector<int64_t>> pay(n);
    for (int i = 0; i < n; i++) {
        tree t;
        t.init(n);
        pay[i].resize(n);
        for (int z = i; z < n; z++) {
            t.put(number[z], products[z]);
            pay[i][z] = t.get((z - i + 1) / 10);
        }
    }

    vector<int64_t> dp(n + 1);
    for (int i = n - 1; i >= 0; i--) {
        dp[i] = LLONG_MAX;
        for (int j = i; j < n; j++)
            dp[i] = min(dp[i], pay[i][j] + dp[j + 1]);
    }

    cout << dp[0] << endl;
}
