// n^3 * log(n) solution

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <climits>
using namespace std;



int main() {
    int n;
    vector<int> products;

    cin >> n;
    products.resize(n);
    for (int i = 0; i < n; i++)
        cin >> products[i];

    vector<vector<int64_t>> f(n);
    for (int a = 0; a < n; a++) {
        f[a].resize(n);
        vector<int> cur;
        int64_t sum = 0;
        for (int b = a; b < n; b++) {
            cur.push_back(products[b]);
            sum += products[b];

            sort(cur.begin(), cur.end());
            int64_t cash_back = 0;
            for (int i = 0; (i + 1) * 10 <= (b - a + 1); i++)
                cash_back += cur[i];

            f[a][b] = sum - cash_back;
        }
    }

    vector<int64_t> dp(n + 1);
    for (int i = n - 1; i >= 0; i--) {
        dp[i] = LLONG_MAX;
        for (int j = i; j < n; j++) {
            dp[i] = min(dp[i], f[i][j] + dp[j + 1]);
        }
    }

    cout << dp[0] << endl;
}
